<#ibizinclude>
../@MACRO/LAYOUTPANEL_VIEW.template.ftl
</#ibizinclude>
// 基于 @VIEW/实体编辑视图 (可查看可编辑)/VIEW-BASE.vue.ftl 生成
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch,Inject } from 'vue-property-decorator';
import { UIActionTool, Util, ViewTool } from '@/utils';
import axios from 'axios';
import { AppMessageBox } from '@/utils/app-message-box/app-message-box';
import NavDataService from '@/service/app/navdata-service';
<#if view.getPSAppCounterRefs()??>
    <#list view.getPSAppCounterRefs() as singleCounterRef>
        <#if singleCounterRef.getPSAppCounter()??>
            <#assign appCounter = singleCounterRef.getPSAppCounter()/>
import  ${srfclassname('${appCounter.getCodeName()}')}CounterService  from '@/counter/${srffilepath2(appCounter.getCodeName())}/${srffilepath2(appCounter.getCodeName())}-counter';
        </#if>
    </#list>
</#if>
import { Subject,Subscription } from 'rxjs';
<#if view.getPSAppDataEntity?? && view.getPSAppDataEntity()??>
    <#assign appde = view.getPSAppDataEntity()/>
import ${srfclassname('${appde.getCodeName()}')}Service from '@/service/${srffilepath2(appde.getCodeName())}/${srffilepath2(appde.getCodeName())}-service';
import ${srfclassname('${appde.getCodeName()}')}AuthService from '@/authservice/${srffilepath2(appde.getCodeName())}/${srffilepath2(appde.getCodeName())}-auth-service';
</#if>

<#if view.getPSUIActions()??>
    <#list view.getPSUIActions() as uiAction>
        <#if uiAction.getPSAppDataEntity?? && uiAction.getPSAppDataEntity()??>
            <#if uiAction.getPFLogicCodeType() == "WFBACKEND">
                <#if uiAction.getPSAppWFVer?? && uiAction.getPSAppWFVer()??>
                    <#if !P.exists("importService", uiAction.getPSAppWFVer().getCodeName(), "")>
import ${srfclassname('${uiAction.getPSAppWFVer().getCodeName()}')}WFUIService from '@/wfuiservice/${uiAction.getPSAppWF().getCodeName()?lower_case}/${uiAction.getPSAppWFVer().getCodeName()?lower_case}-ui-service';
                    </#if>
                </#if>
            </#if>
        </#if>
    </#list>
</#if>
<#if appde??>
import ${srfclassname('${appde.getCodeName()}')}UIService from '@/uiservice/${srffilepath2(appde.getCodeName())}/${srffilepath2(appde.getCodeName())}-ui-service';
</#if>
<#if view.getPSViewLayoutPanel()?? && !view.getPSViewLayoutPanel().isUseDefaultLayout()>
import { PanelContainerModel, PanelRawitemModel, PanelFieldModel, PanelControlModel, PanelButtonModel, PanelUserControlModel, PanelTabPanelModel, PanelTabPageModel, PanelCtrlPosModel} from '@/model/panel-detail';
</#if>

@Component({
    components: {
    },
})
export default class ${srfclassname('${view.name}')}Base extends Vue {
<#if view.getPSAppDataEntity?? && view.getPSAppDataEntity()??>
    <#assign appde = view.getPSAppDataEntity()/>

    /**
     * 实体服务对象
     *
     * @type {${srfclassname('${appde.getCodeName()}')}Service}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public appEntityService: ${srfclassname('${appde.getCodeName()}')}Service = new ${srfclassname('${appde.getCodeName()}')}Service();

    /**
     * 实体UI服务对象
     *
     * @type ${srfclassname('${appde.getCodeName()}')}UIService
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public appUIService: ${srfclassname('${appde.getCodeName()}')}UIService = new ${srfclassname('${appde.getCodeName()}')}UIService();
</#if>
    
    /**
     * 数据变化
     *
     * @param {*} val
     * @returns {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Emit() 
    public viewDatasChange(val: any):any {
        return val;
    }

    /**
     * 传入视图上下文
     *
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Prop() public viewdata!: string;

    /**
     * 传入视图参数
     *
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Prop() public viewparam!: string;

    /**
     * 视图默认使用
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Prop({ default: true }) public viewDefaultUsage!: boolean;

<#if view.getViewType() != "APPINDEXVIEW">
    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;
</#if>

	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof ${srfclassname('${view.name}')}Base
	 */
	public viewtag: string = '${view.getId()}';

    /**
	 * 视图类型
	 *
	 * @type {string}
	 * @memberof ${srfclassname('${view.name}')}Base
	 */
	public viewType: string = '${view.getViewType()}';
<#assign viewStateFormName = ''>
<#assign editStateFormName = ''>
<#if view.getPSControls?? && view.getPSControls()??>
    <#list view.getPSControls() as childCtrl>
        <#if childCtrl.getControlType() == 'FORM'>
            <#if childCtrl.getUserTag?? && childCtrl.getUserTag()?? && childCtrl.getUserTag() == 'VIEW'>
                <#assign viewStateFormName = childCtrl.name>
            <#else>
                <#assign editStateFormName = childCtrl.name>
            </#if>
        </#if>
        <#if childCtrl.getControlType() == 'TOOLBAR'>
            <#if childCtrl.getUserTag?? && childCtrl.getUserTag()?? && childCtrl.getUserTag() == 'VIEW'>
                <#assign viewStateToolbar = childCtrl>
            <#else>
                <#assign editStateToolbar = childCtrl>
            </#if>
        </#if>
    </#list>
</#if>
    /**
	 * 是否编辑模式
	 *
	 * @type {boolean}
	 * @memberof ${srfclassname('${view.name}')}Base
	 */
    public editMode: boolean = true;
    /**
	 * 获取激活表单
	 *
	 * @type {string}
	 * @memberof ${srfclassname('${view.name}')}Base
	 */
    public getForm(): any {
        if (!this.$refs) {
            return null;
        }
<#if editStateFormName != ''>
        if (this.editMode) {
            return this.$refs.${editStateFormName};
        }
</#if>
<#if viewStateFormName != ''>
        return this.$refs.${viewStateFormName};
<#else>
        return null;
</#if>
    }

    /**
	 * 获取激活工具栏模型
	 *
	 * @type {string}
	 * @memberof ${srfclassname('${view.name}')}Base
	 */
    public getToolbarModels(): any[] {
<#if editStateToolbar??>
        if (this.editMode) {
    <#if editStateToolbar.getName() != 'toolbar'>
            return this.${editStateToolbar.getCodeName()?lower_case}Models;
    <#else>
            return this.toolBarModels;
    </#if>
        }
</#if>
<#if viewStateToolbar??>
    <#if viewStateToolbar.getName() != 'toolbar'>
            return this.${viewStateToolbar.getCodeName()?lower_case}Models;
    <#else>
            return this.toolBarModels;
    </#if>
<#else>
        return [];
</#if>
    }

	/**
	 * 自定义视图导航上下文集合
	 *
	 * @type {*}
	 * @memberof ${srfclassname('${view.name}')}Base
	 */
    public customViewNavContexts:any ={
<#if view.getPSAppViewNavContexts()??>
    <#list view.getPSAppViewNavContexts() as viewNavContext>
    "${viewNavContext.getKey()}":{"isRawValue":${viewNavContext.isRawValue()?c},"value":"${viewNavContext.getValue()}"}<#if viewNavContext_has_next>,</#if>
    </#list>
</#if>
    };

	/**
	 * 自定义视图导航参数集合
	 *
	 * @type {*}
	 * @memberof ${srfclassname('${view.name}')}Base
	 */
    public customViewParams:any ={
<#if view.getPSAppViewNavParams()??>
    <#list view.getPSAppViewNavParams() as viewNavParam>
    "${viewNavParam.getKey()}":{"isRawValue":${viewNavParam.isRawValue()?c},"value":"${viewNavParam.getValue()}"}<#if viewNavParam_has_next>,</#if>
    </#list>
</#if>
    };

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public model: any = {
        srfCaption: <#if view.getCapPSLanguageRes()??>this.$t('${view.getCapPSLanguageRes().getLanResTag()}','<#if view.getCaption()??>${view.getCaption()}</#if>')<#else>'<#if view.getCaption()??>${view.getCaption()}</#if>'</#if>,
        srfTitle: <#if view.getTitlePSLanguageRes()??>this.$t('${view.getTitlePSLanguageRes().getLanResTag()}','<#if view.getTitle()??>${view.getTitle()}</#if>')<#else>'<#if view.getTitle()??>${view.getTitle()}</#if>'</#if>,
        srfSubTitle: <#if view.getSubCapPSLanguageRes()??>this.$t('${view.getSubCapPSLanguageRes().getLanResTag()}','<#if view.getSubCaption()??>${view.getSubCaption()}</#if>')<#else>'<#if view.getSubCaption()??>${view.getSubCaption()}</#if>'</#if>,
        dataInfo: ''
    }

    /**
     * 是否默认加载
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public isLoadDefault: boolean = <#if view.isLoadDefault?? && !view.isLoadDefault()>false<#else>true</#if>;

    /**
     * 视图参数变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Watch('viewparam',{immediate: true, deep: true})
    onParamData(newVal: any, oldVal: any) {
        if (newVal) {
            this.viewparams = {};
            if (typeof newVal == 'string') {
                Object.assign(this.viewparams, JSON.parse(this.viewparam));
            } else {
                this.viewparams = Util.deepCopy(this.viewparam);
            }
            if (this.viewparams && (this.viewparams.srfeditmode === 'false' || this.viewparams.srfeditmode === false)) {
                this.editMode = false;
            }
        } 
    }

    /**
     * 处理应用上下文变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Watch('viewdata')
    onViewData(newVal: any, oldVal: any) {
        const _this: any = this;
        if (!Object.is(newVal, oldVal)) {
            this.$nextTick(() => {
                _this.parseViewParam();
                _this.formLoad();
            });
        } else if (!Object.is(newVal, oldVal) && _this.refresh && _this.refresh instanceof Function) {
            _this.refresh();
        }
    }

    /**
     * 容器模型
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public containerModel: any = {
<#if view.getPSControls()??>
    <#list view.getPSControls() as ctrl>
        view_${ctrl.name}: { name: '${ctrl.name}', type: '${ctrl.getControlType()}' },
    </#list>
</#if>
<#if view.getPSWorkflow?? && view.getPSWorkflow()??>
        wflinks: [],
</#if>
    };

    /**
     * 视图操作参数
     *
     * @type {*}
     * @readonly
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public viewCtx: any = {};

<#if view.getXDataPSControl?? && view.getXDataPSControl()??>
        <#assign dataControl = view.getXDataPSControl()/>
    /**
     * 视图刷新
     *
     * @param {*} args
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public refresh(args?: any): void {
        const form = this.getForm();
        if (form) {
            form.refresh();
        }
    }
</#if>
    /**
     *  计数器刷新
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public viewState: Subject<ViewState> = new Subject();
<#if view.getPSControls()??>
    <#list view.getPSControls() as childCtrl>
        <#if childCtrl.getControlType() == 'TOOLBAR'>
    ${P.getCtrlCode(childCtrl, 'CONTROL.vue').code}
        </#if>
    </#list>
</#if>

<#ibizinclude>
../@MACRO/WF_VIEW_CONTENT.vue.ftl
</#ibizinclude>

    /**
     * 引擎初始化
     *
     * @public
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public engineInit(): void {
        const form = this.getForm();
        if (form && this.isLoadDefault) {
            this.formLoad();
        }
        this.isLoadDefault = false;
    }

    /**
     * 表单加载
     *
     * @public
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public formLoad() {
<#if appde??>
        const action = this.context['${appde.getCodeName()?lower_case}'] && !Object.is(this.context['${appde.getCodeName()?lower_case}'], '') ? 'load' : 'loaddraft';
        this.viewState.next({ tag: this.editMode ? '${editStateFormName}' : '${viewStateFormName}', action, data: this.viewparams });
</#if>
    }

    /**
     * 应用导航服务
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public navDataService = NavDataService.getInstance();

    /**
    * 导航服务事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof ${srfclassname('${view.name}')}Base
    */
    public serviceStateEvent: Subscription | undefined;

    /**
     * 门户部件状态对象
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Prop() public portletState?: any;

    /**
     * 门户部件状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public portletStateEvent: Subscription | undefined;

    /**
     * 门户部件状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public formDruipartEvent: Subscription | undefined;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public context:any = {};

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public viewparams:any = {};

    /**
     * 视图缓存数据
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public viewCacheData:any;

<#if view.getPSAppCounterRefs()??>
    <#assign counterRefs = ''/>
    <#list view.getPSAppCounterRefs() as singleCounterRef>
        <#if singleCounterRef.getPSAppCounter()??>
            <#assign appCounter = singleCounterRef.getPSAppCounter()/>
            <#assign counterRefs>${counterRefs}this.${appCounter.getCodeName()?lower_case}counterservice<#if singleCounterRef_has_next>,</#if></#assign>

    /**
     * ${srfclassname('${appCounter.getCodeName()}')}CounterService计数器服务对象
     *
     * @type {${srfclassname('${appCounter.getCodeName()}')}CounterService}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public ${appCounter.getCodeName()?lower_case}counterservice: ${srfclassname('${appCounter.getCodeName()}')}CounterService = new ${srfclassname('${appCounter.getCodeName()}')}CounterService({context:this.context,viewparams:this.viewparams});
        </#if>
    </#list>

    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof ${srfclassname('${view.name}')}Base
     */    
    public counterServiceArray:Array<any> = [${counterRefs}];
</#if>

    /**
     * 解析视图参数
     *
     * @public
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public parseViewParam(inputvalue: any = null): void {
        for (let key in this.context) {
            delete this.context[key];
        }
        if (this.$store.getters.getAppData() && this.$store.getters.getAppData().context) {
            Object.assign(this.context,this.$store.getters.getAppData().context);
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            if(typeof this.viewdata == 'string') {
                Object.assign(this.context, JSON.parse(this.viewdata));
            }
            if(this.context && this.context.srfparentdename){
                Object.assign(this.viewparams,{srfparentdename:this.context.srfparentdename});
            }
            if(this.context && this.context.srfparentkey){
                Object.assign(this.viewparams,{srfparentkey:this.context.srfparentkey});
            }
            this.handleCustomViewData();
            <#if self_viewparam??>
            ${self_viewparam}
            </#if>
            return;
        }
        const path = (this.$route.matched[this.$route.matched.length - 1]).path;
        const keys: Array<any> = [];
        const curReg = this.$pathToRegExp.pathToRegexp(path, keys);
        const matchArray = curReg.exec(this.$route.path);
        let tempValue: Object = {};
        keys.forEach((item: any, index: number) => {
            if(matchArray[index + 1]){
                Object.defineProperty(tempValue, item.name, {
                    enumerable: true,
                    value: decodeURIComponent(matchArray[index + 1])
                });
            }
        });
        this.$viewTool.formatRouteParams(tempValue,this.$route,this.context,this.viewparams);
        <#if appde??>
        if(inputvalue){
            Object.assign(this.context,{'${appde.getCodeName()?lower_case}':inputvalue});
        }
        </#if>
        <#if view.isPSDEView()>
        //初始化视图唯一标识
        Object.assign(this.context,{srfsessionid:this.$util.createUUID()});
        </#if>
        this.handleCustomViewData();
        //初始化导航数据
        this.initNavDataWithRoute();
        if (this.viewparams && (this.viewparams.srfeditmode === 'false' || this.viewparams.srfeditmode === false)) {
            this.editMode = false;
        }
    }

    /**
     * 处理自定义视图数据
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
	public handleCustomViewData(){
        <#if view.getPSDER1N?? && view.getPSDER1N()??>
        this.handleviewRes();
        </#if>
		if(Object.keys(this.customViewNavContexts).length > 0){
			Object.keys(this.customViewNavContexts).forEach((item:any) =>{
				let tempContext:any = {};
				let curNavContext:any = this.customViewNavContexts[item];
				this.handleCustomDataLogic(curNavContext,tempContext,item);
				Object.assign(this.context,tempContext);
			})
		}
		if(Object.keys(this.customViewParams).length > 0){
			Object.keys(this.customViewParams).forEach((item:any) =>{
				let tempParam:any = {};
				let curNavParam:any = this.customViewParams[item];
				this.handleCustomDataLogic(curNavParam,tempParam,item);
				Object.assign(this.viewparams,tempParam);
			})
		}
	}

    /**
     * 处理自定义视图数据逻辑
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
	public handleCustomDataLogic(curNavData:any,tempData:any,item:string){
		// 直接值直接赋值
		if(curNavData.isRawValue){
			if(Object.is(curNavData.value,"null") || Object.is(curNavData.value,"")){
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: null,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }else{
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: curNavData.value,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }
		}else{
			// 先从导航上下文取数，没有再从导航参数（URL）取数，如果导航上下文和导航参数都没有则为null
			if(this.context[(curNavData.value).toLowerCase()] != null){
				Object.defineProperty(tempData, item.toLowerCase(), {
					value: this.context[(curNavData.value).toLowerCase()],
					writable : true,
					enumerable : true,
					configurable : true
				});
			}else{
				if(this.viewparams[(curNavData.value).toLowerCase()] != null){
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: this.viewparams[(curNavData.value).toLowerCase()],
						writable : true,
						enumerable : true,
						configurable : true
					});
				}else{
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: null,
						writable : true,
						enumerable : true,
						configurable : true
					});
				}
			}
		}
	}

    /**
     * 初始化导航数据(路由模式)
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public initNavDataWithRoute(data:any = null, isNew:boolean = false,  isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && Object.is(this.navModel,"route")) ){
            this.navDataService.addNavData({id:'${srffilepath2(view.getCodeName())}',tag:this.viewtag,srfkey:isNew ? null : <#if appde??>this.context.${appde.getCodeName()?lower_case}<#else>null</#if>,title:this.model.srfCaption,data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath});
        }
    }

    /**
     * 初始化导航数据(分页模式)
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public initNavDataWithTab(data:any = null,isOnlyAdd:boolean = true, isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && !Object.is(this.navModel,"route")) ){
            this.navDataService.addNavDataByOnly({id:'${srffilepath2(view.getCodeName())}',tag:this.viewtag,srfkey:<#if appde??>this.context.${appde.getCodeName()?lower_case}<#else>null</#if>,title:this.model.srfCaption,data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath},isOnlyAdd);
        }
    }
	
<#if view.getPSDER1N?? && view.getPSDER1N()??>
    /**
     * 处理指定视图控制关系将父键转为父实体上下文
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public handleviewRes(){
    <#assign viewRes = view.getPSDER1N()/>
    <#if viewRes.getMajorPSDataEntity()??>
    <#assign majorAppDataEntity = viewRes.getMajorPSDataEntity() />
    if(this.context.srfparentkey){
        Object.assign(this.context,{'${majorAppDataEntity.getCodeName()?lower_case}':this.context.srfparentkey});
    }
    </#if>
    }
</#if>

    /**
     * Vue声明周期
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */    
    public afterCreated(){
        let _this:any = this;
        const secondtag = _this.$util.createUUID();
        _this.$store.commit('viewaction/createdView', { viewtag: _this.viewtag, secondtag: secondtag });
        _this.viewtag = secondtag;
        _this.parseViewParam();
        _this.serviceStateEvent = _this.navDataService.serviceState.subscribe(({ action,name, data }:{ action:string,name:any,data:any }) => {
            if(!Object.is(name,'${srffilepath2(view.getCodeName())}')){
                return;
            }
            if (Object.is(action, 'viewrefresh')) {
                _this.$nextTick(()=>{
                    _this.parseViewParam(data);
                    this.formLoad();
                }); 
            }
        });
        if(_this.portletState){
            _this.portletStateEvent = _this.portletState.subscribe((res:any) =>{
                if(!Object.is(res.name,'${view.getName()}')){
                    return;
                }
                if(Object.is(res.action,'refresh') && _this.refresh && _this.refresh instanceof Function){
                    _this.refresh();
                }
            })
        }
        _this.initViewCtx();
    }

    /**
     * 初始化视图操作参数
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */  
    initViewCtx() {
        Object.assign(this.viewCtx, {
            app: this.$root,
            view: this,
            viewGlobal: {},
            viewNavData: {},
            viewNavContext: this.context,
            viewNavParam: this.viewparams,
            messagebox: AppMessageBox.getInstance(),
        });
        Object.assign(this.viewCtx, { appGlobal: this.$store.getters.getAppGlobal() });
        if (this.$store.getters.getRouteViewGlobal(this.context.srfsessionid)) {
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        } else {
            this.$store.commit('addRouteViewGlobal', { tag: this.context.srfsessionid, param: {} });
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            //  嵌入视图
            Object.assign(this.viewCtx, {
                topview: this.$store.getters.getView(this.context.srfsessionid)
            });
        } else {
            //  顶层视图
            this.$store.commit('addView', { tag: this.context.srfsessionid, param: this });
            Object.assign(this.viewCtx, { topview: this });
        }
    }

    /**
     * 销毁之前
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public beforeDestroy() {
        this.$store.commit('viewaction/removeView', this.viewtag);

        let _this: any = this
        if (_this.serviceStateEvent) {
            _this.serviceStateEvent.unsubscribe();
        }
        if (_this.portletStateEvent) {
            _this.portletStateEvent.unsubscribe();
        }
        if (_this.formDruipartEvent) {
            _this.formDruipartEvent.unsubscribe();
        }
    }

    /**
     * Vue声明周期(组件初始化完毕)
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public mounted() {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     * 
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public afterMounted(){
        const _this: any = this;
<#assign afterMountedBlock>
        _this.engineInit();
        if (_this.loadModel && _this.loadModel instanceof Function) {
            _this.loadModel();
        }
</#assign>
<#assign hasLogic = false>
<#if view.getPSAppViewLogics?? && view.getPSAppViewLogics()??>
    <#list view.getPSAppViewLogics() as logic>
        <#if logic.getLogicTrigger?? && logic.getLogicTrigger()?? && logic.getLogicTrigger() == 'VIEWEVENT' && logic.getEventNames?? && logic.getEventNames()?? && logic.getEventNames()?index_of("onViewMounted") != -1>
            <#--  暂时只支持实体界面逻辑  -->
            <#if logic.getLogicType() == 'DEUILOGIC' && logic.getPSAppDEUILogic?? && logic.getPSAppDEUILogic()??>
                <#assign hasLogic = true>
            window.uiServiceRegister.getService('${logic.getPSAppDEUILogic().getPSAppDataEntity().codeName?lower_case}').then((service: any) => {
                service.executeUILogic('${logic.getPSAppDEUILogic().codeName}', [], this.context, this.viewparams, {}, {}, this, '${logic.getPSAppDEUILogic().getPSAppDataEntity().codeName}').then((result: any) => {
                    if (result && result.hasOwnProperty('srfret') && !result.srfret) {
                        return;
                    }
                    <@ibizindent blank=20>
                    ${afterMountedBlock}
                    </@ibizindent>
                });
            })
            </#if>
        </#if>
    </#list>
</#if>
<#if !hasLogic>
    <@ibizindent blank=0>
    ${afterMountedBlock}
    </@ibizindent>
</#if>
    }

<#if view.getPSControls()??>
    <#list view.getPSControls() as ctrl>
        <#if ctrl.getControlType()?? && ctrl.getControlType() != 'FORM'>
            <#if ctrl.getHookEventNames()??>
                <#list ctrl.getHookEventNames() as eventName>
    /**
     * ${ctrl.name} 部件 ${eventName?lower_case} 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public ${ctrl.name}_${eventName?lower_case}($event: any, $event2?: any) {
                    <#if ctrl.getPSControlLogics(eventName)??>
                        <#list ctrl.getPSControlLogics(eventName) as ctrlLogic>
                            <#if ctrlLogic.getLogicType() == "APPVIEWENGINE" && ctrlLogic.getPSAppViewEngine()??>
        this.${ctrlLogic.getPSAppViewEngine().getName()}.onCtrlEvent('${ctrl.name}', '${eventName?lower_case}', $event);
                            <#else>
                                <#assign isCtrlEvent = false>
                                <#if view.getPSAppViewLogics?? && view.getPSAppViewLogics()??>
                                    <#list view.getPSAppViewLogics() as viewLogic>
                                        <#if viewLogic.getLogicTrigger() == "CTRLEVENT" && viewLogic.name == ctrlLogic.name>
                                            <#assign isCtrlEvent = true>
                                        </#if>
                                    </#list>
                                </#if>
                                <#if isCtrlEvent>
                                    <#if ctrlLogic.getEventArg()?? && ctrlLogic.getEventArg()?length gt 0>
        if (Object.is($event.tag, '${ctrlLogic.getEventArg()}')) {
            this.${ctrlLogic.name}(null, '', $event2);
        }
                                    <#else>
        this.${ctrlLogic.name}($event, '', $event2);
                                    </#if>
                                </#if>
                            </#if>
                        </#list>
                    </#if>
    }
                </#list>
            </#if>
        </#if>
    </#list>
</#if>
    /**
     * form 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public formLoadFinish($event: any, $event2?: any) {
<#if appde?? && appde.getMajorPSAppDEField()??>
        this.model.dataInfo = Object.is($event.srfuf, '1') ? $event['${appde.getMajorPSAppDEField().codeName?lower_case}'] : 'app.local.new';
<#else>
        this.model.dataInfo = Object.is($event.srfuf, '1') ? $event['srfmajortext'] : 'app.local.new';
</#if>
        this.setTabCaption(this.model.dataInfo, Object.is($event.srfuf, '1'));
        const newdata: boolean = !Object.is($event.srfuf, '1');
        const toolbarModels = this.getToolbarModels();
        this.calcToolbarItemState(newdata, toolbarModels);
        ViewTool.calcActionItemAuthState($event, toolbarModels, this.appUIService);
    }

    /**
     * 计算工具栏权限
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public calcToolbarItemState(state: boolean, toolbarModels: any[]) {
        if (!toolbarModels || Object.keys(toolbarModels).length === 0) {
            return;
        }
        for (const key in toolbarModels) {
            if (!toolbarModels.hasOwnProperty(key)) {
                return;
            }
            const _item = toolbarModels[key];
            if (_item.uiaction && (Object.is(_item.uiaction.target, 'SINGLEKEY') || Object.is(_item.uiaction.target, 'MULTIKEY'))) {
                _item.disabled = state;
            }
            _item.visabled = true;
            if(_item.noprivdisplaymode && _item.noprivdisplaymode === 6){
                _item.visabled = false;
            }
        }
    }

    /**
     * 转化数据
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public transformData(data: any) {
        const form = this.getForm();
        if (form && form.transformData instanceof Function) {
            return form.transformData(data);
        }
        return null;
    }

    /**
     * 设置分页标题
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public setTabCaption(info: string, isNew: boolean) {
        if (this.model && info && !Object.is(info, '')) {
            let index:number = this.model.srfCaption.indexOf("-");
            if(index !== -1){
                this.model.srfCaption = this.model.srfCaption.substr(0,index);
            }
            // 解决表格视图标题问题
            if (this.$tabPageExp && this.viewDefaultUsage) {
                this.$tabPageExp.setCurPageCaption(this.model.srfCaption, info);
            }
            if (this.$route && this.$route.meta) {
                this.$route.meta.info = info;
            }
            <#noparse>this.model.srfCaption = `${this.model.srfCaption}-${this.model.dataInfo}`;</#noparse>
            this.initNavDataWithRoute(null,isNew);
        }
    }

    /**
     * form 部件 save 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public formSaveFinish($event: any, $event2?: any) {
<#if appde?? && appde.getMajorPSAppDEField()??>
        this.model.dataInfo = Object.is($event.srfuf, '1') ? $event['${appde.getMajorPSAppDEField().codeName?lower_case}'] : 'app.local.new';
<#else>
        this.model.dataInfo = Object.is($event.srfuf, '1') ? $event['srfmajortext'] : 'app.local.new';
</#if>
        this.setTabCaption(this.model.dataInfo, Object.is($event.srfuf, '1'));
        const newdata: boolean = !Object.is($event.srfuf, '1');
        const toolbarModels = this.getToolbarModels();
        this.calcToolbarItemState(newdata, toolbarModels);
        ViewTool.calcActionItemAuthState($event, toolbarModels, this.appUIService);
        this.$emit('save', $event);
        this.$emit('viewdataschange', JSON.stringify({ action: 'save', status: 'success', data: $event }));
    }
    /**
     * form 部件 remove 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public formRemoveFinish($event: any, $event2?: any) {
        this.$emit('remove', $event);
        this.$emit('viewdataschange', JSON.stringify({ action: 'remove', status: 'success', data: $event }));
    }
<#if view.getPSAppViewLogics()??>
    <#list view.getPSAppViewLogics() as logic>
        <#if logic.getLogicTrigger() == "CUSTOM" || logic.getLogicTrigger() == "CTRLEVENT">
            <#if logic.getLogicType?? && logic.getLogicType()?? && logic.getLogicType() == 'APPVIEWUIACTION'>
    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public ${logic.name}(params: any = {}, tag?: any, $event?: any) {
<#--  触发逻辑类型为APPVIEWUIACTION且存在视图界面行为  -->
                <#if logic.getLogicType() == 'APPVIEWUIACTION' && logic.getPSAppViewUIAction()??>
                    <#assign uiAction = logic.getPSAppViewUIAction().getPSUIAction() />
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
                    <#--  是否存在界面行为数据部件  -->
                    <#if logic.getPSAppViewUIAction().getXDataPSControl?? && logic.getPSAppViewUIAction().getXDataPSControl()??>
                        <#assign xData = logic.getPSAppViewUIAction().getXDataPSControl()/>
      <#--  界面行为数据部件与控件容器不同时，即逻辑事件在视图里时  -->
                            <#if xData != logic.getPSAppViewUIAction().getPSControlContainer()>
        xData = this.getForm();
        if (xData.getDatas && xData.getDatas instanceof Function) {
            datas = [...xData.getDatas()];
        }
      <#--  界面行为数据部件与控件容器相同时  -->
                            <#else>
        xData = this;
                                <#if xData.getControlType?? && xData.getControlType() == 'VIEWLAYOUTPANEL'>
        datas = [this.layoutData];
                                <#else>
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
                                </#if>
                            </#if>
                        <#else>
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
                    </#if>
        if(params){
          datas = [params];
        }
        // 界面行为
                    <#if logic.getPSAppViewUIAction().getPSUIAction()??>
                        <#assign uiaction = logic.getPSAppViewUIAction().getPSUIAction()/>
        <#-- 属于应用实体的界面行为走UI服务start -->
                        <#if uiaction.getPSAppDataEntity?? && uiaction.getPSAppDataEntity()??>
                            <#assign curAppEntity = uiaction.getPSAppDataEntity() />
                            <#if uiaction.getPSAppWFVer?? && uiaction.getPSAppWFVer()??>
        const curUIService:${srfclassname('${uiaction.getPSAppWFVer().getCodeName()}')}WFUIService = new ${srfclassname('${uiaction.getPSAppWFVer().getCodeName()}')}WFUIService();
                            <#else>
        const curUIService:${srfclassname('${curAppEntity.getCodeName()}')}UIService  = new ${srfclassname('${curAppEntity.getCodeName()}')}UIService();
                            </#if>
                            <#if logic.getPSControlContainer()?? && logic.getPSControlContainer().getPSAppDataEntity()??>
                                <#assign appDataEntity = logic.getPSControlContainer().getPSAppDataEntity()/>
        curUIService.${uiaction.getFullCodeName()}(datas,contextJO, paramJO,  $event, xData,this,<#if appDataEntity??>"${appDataEntity.getCodeName()}"<#else>null</#if>);
                            </#if>
                        <#else>
                            <#if logic.getPSControlContainer()?? && logic.getPSControlContainer().getPSAppDataEntity()??>
                                <#assign appDataEntity = logic.getPSControlContainer().getPSAppDataEntity()/>
        this.${uiaction.getFullCodeName()}(datas, contextJO,paramJO,  $event, xData,this,"${appDataEntity.getCodeName()}");
                            <#else>
        this.${uiaction.getFullCodeName()}(datas, contextJO,paramJO,  $event, xData,this,undefined);
                            </#if>
                        </#if>
        <#-- 属于应用实体的界面行为走UI服务end -->
                    </#if>
                </#if>
    }
            <#else>
            ${P.getLogicCode(logic, "LOGIC.vue").code}
            </#if>
        </#if>
    </#list>
</#if>

<#if view.getPSAppViewUIActions()??>
    <#list view.getPSAppViewUIActions() as viewUIAction>
        <#if viewUIAction.getPSUIAction()?? >
            <#assign uiAction = viewUIAction.getPSUIAction()/>
            <#if !P.exists("importService", uiAction.getFullCodeName(), "")>
<#-- 系统预置界面行为输入start -->
                <#if !(uiAction.getPSAppDataEntity?? && uiAction.getPSAppDataEntity()??)>
${P.getLogicCode(uiAction, "LOGIC.vue").code}
                </#if>
<#-- 系统预置界面行为输入end -->
            </#if>
        </#if>
    </#list>
</#if>

    /**
     * 关闭视图
     *
     * @param {any[]} args
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public closeView(args: any[]): void {
        let _view: any = this;
        if (_view.viewdata) {
            _view.$emit('viewdataschange', Array.isArray(args)?args:[args]);
            _view.$emit('close', Array.isArray(args)?args:[args]);
        } else if (_view.$tabPageExp) {
            _view.$tabPageExp.onClose(_view.$route.fullPath);
        } else {
            _view.$router.back();
        }
    }
<#if view.isPSDEView()>
    <#if view.getPSAppDataEntity()??>
        <#assign appDataEntity = view.getPSAppDataEntity() />
        <#if appDataEntity.isMajor()>

    /**
     * 销毁视图回调
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public destroyed(){
        this.afterDestroyed();
    }

    /**
     * 执行destroyed后的逻辑
     * 
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public afterDestroyed(){
    <#assign afterDestroyedBlock>
        if (this.viewDefaultUsage) {
            let localStoreLength = Object.keys(localStorage);
            if(localStoreLength.length > 0){
                localStoreLength.forEach((item:string) =>{
                if(item.startsWith(this.context.srfsessionid)){
                    localStorage.removeItem(item);
                }
                })
            }
            if(Object.is(this.navModel,"tab")){
                this.navDataService.removeNavDataByTag(this.viewtag);
            }
        }
        // 销毁计数器定时器
        if(this.counterServiceArray && this.counterServiceArray.length >0){
            this.counterServiceArray.forEach((item:any) =>{
                if(item.destroyCounter && item.destroyCounter instanceof Function){
                    item.destroyCounter();
                }
            })
        }
    </#assign>
    <#assign hasLogic = false>
        <#if view.getPSAppViewLogics?? && view.getPSAppViewLogics()??>
            <#list view.getPSAppViewLogics() as logic>
                <#if logic.getLogicTrigger?? && logic.getLogicTrigger()?? && logic.getLogicTrigger() == 'VIEWEVENT' && logic.getEventNames?? && logic.getEventNames()?? && logic.getEventNames()?index_of("onViewDestroyed") != -1>
            <#--  暂时只支持实体界面逻辑  -->
                    <#if logic.getLogicType() == 'DEUILOGIC' && logic.getPSAppDEUILogic?? && logic.getPSAppDEUILogic()??>
                        <#assign hasLogic = true>
        window.uiServiceRegister.getService('${logic.getPSAppDEUILogic().getPSAppDataEntity().codeName?lower_case}').then((service: any) => {
            service.executeUILogic('${logic.getPSAppDEUILogic().codeName}', [], this.context, this.viewparams, {}, {}, this, '${logic.getPSAppDEUILogic().getPSAppDataEntity().codeName}').then((result: any) => {
                if (result && result.hasOwnProperty('srfret') && !result.srfret) {
                    return;
                }
                <@ibizindent blank=8>
                ${afterDestroyedBlock}
                </@ibizindent>
            });
        });
                    </#if>
                </#if>
            </#list>
        </#if>
        <#if !hasLogic>
    <@ibizindent blank=0>
    ${afterDestroyedBlock}
    </@ibizindent>
            </#if>
    }
        </#if>
    </#if>
</#if>

<#if view.getPSAppViewRefs?? && view.getPSAppViewRefs()??>
    /**
     * 视图引用数据
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public viewRefData:any = {
    <#list view.getPSAppViewRefs() as viewRef>
        <#if viewRef.getName?? && viewRef.getName()?? && viewRef.getRefPSAppView?? && viewRef.getRefPSAppView()??>
            <#assign refAppView = viewRef.getRefPSAppView() />
        "${viewRef.getName()}":{viewname:"${srffilepath2(refAppView.getCodeName())}",title:<#if refAppView.getCapPSLanguageRes?? && refAppView.getCapPSLanguageRes()??>this.$t('${refAppView.getCapPSLanguageRes().getLanResTag()}', '${refAppView.getCaption()}')<#t><#else>'${refAppView.getCaption()}'<#t></#if>, width: <#if refAppView.getWidth?? && refAppView.getWidth() gt 0>${refAppView.getWidth()?c}<#else>800</#if>, height: <#if refAppView.getHeight?? && refAppView.getHeight() gt 0>${refAppView.getHeight()?c}<#else>500</#if>}<#if viewRef_has_next>,</#if>
        </#if>
    </#list>
    };
</#if>

<#ibizinclude>
../@MACRO/VIEW_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW-BASE.style.ftl
</#ibizinclude>